﻿/** CONFIGURATION OPTIONS HERE **/
var docHeight = 267.56;     // Height of the test target's area in mm
var wedgeHeight = 80;       // Length of the wedge in mm
var wedgeSteps = 20;        // Number of segments in the wedgez
var wedgeMinRes = 2000;     // Lowest resolution
var wedgeMaxRes = 4000;     // Hightest Resolution
var lines = 9;              // Number of lines in wedge


var doc = app.activeDocument;
var myLayer = doc.layers.add();

var stepSize = (wedgeMaxRes - wedgeMinRes) / wedgeSteps;        // Size of steps in resolution units
var vOffset = wedgeHeight / wedgeSteps;     // Y-axis positioning steps

var xOrg = 20;      // X Origin
var yOrg = 0 - wedgeHeight - 20;      // Y Origin

var points = [];    
for( n = -lines; n < lines; n++ )
{ 
    for( y = 0; y <= wedgeSteps; y++ )
    {
        var xRes = wedgeMaxRes - (stepSize * y);
        var xOffsetWidth = docHeight / xRes;
        points.push( [ mm2pts(xOrg + (xOffsetWidth * n)), mm2pts(yOrg + (y * vOffset )) ] );
    }
    n++;
    
    for( y = wedgeSteps; y >= 0; y-- )
    {
        var xRes = wedgeMaxRes - (stepSize * y);
        var xOffsetWidth = docHeight / xRes;
        points.push( [ mm2pts(xOrg + (xOffsetWidth * n)), mm2pts(yOrg + (y * vOffset )) ] );
    }
}
var line = myLayer.pathItems.add();
line.stroked = false;
line.fillColor = new RGBColor(0,0,0);
line.setEntirePath( points );



var layer2 = myLayer.layers.add();
for( y = 1; y <= wedgeSteps; y++ )
{
    var xRes = wedgeMaxRes - ( stepSize * y );
    var xOffset = docHeight / xRes
    var xPos = xOrg + (xOffset * lines ) + 2;
    var len = 4;
    
    line = layer2.pathItems.add();
    line.stroked = true;
    line.strokeWidth = 1;

    if( y % 2 != 0 ) 
    {
        len = 2.5;
    }
    else { len = 4; }
    
    line.setEntirePath ( [ [ mm2pts( xPos ), mm2pts( yOrg + (y * vOffset) ) ],
                            [mm2pts( xPos + len ), mm2pts( yOrg + (y * vOffset ) ) ] ] );
                                                   
    if( y % 2 == 0 ) {    
        var text = layer2.textFrames.add();
        text.position = [mm2pts( xPos + 6 ), mm2pts( yOrg + (y * vOffset ) + 2 ) ];
        text.contents = Math.floor( (wedgeMaxRes - ( stepSize * y ))) / 100;
    }
}
    


function mm2pts ( mm ) {
    return mm / 0.3528;
}